<template>
  <q-page padding>
    <q-toolbar>
      <q-btn to="/" icon="arrow_back" color="secondary" unelevated flat round />
      <q-separator vertical class="q-mx-sm" inset />
      <q-toolbar-title class="text-secondary">
        Pokémons List
      </q-toolbar-title>
      <q-btn
        label="add pokémon"
        @click="addPokemonDialog = true"
        icon="add"
        color="secondary"
        unelevated
      />
    </q-toolbar>
    <PokemonsList
      :pokemons="pokemons"
      :count="pokemonsCount"
      :error="error"
      :loading="loading"
    />
    <q-dialog v-model="addPokemonDialog" persistent>
      <q-card style="width: 700px" class="rounded-borders">
        <q-toolbar class="bg-primary">
          <q-toolbar-title class="text-white">
            New pokémon
          </q-toolbar-title>
        </q-toolbar>
        <q-card-section>
          <PokemonCreateForm />
        </q-card-section>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<style></style>

<script>
import { mapState } from 'vuex'
import PokemonsList from 'src/components/PokemonsList'
import PokemonCreateForm from 'src/components/forms/PokemonCreateForm'

export default {
  name: 'PokemonsPage',
  components: { PokemonsList, PokemonCreateForm },
  data: () => ({
    addPokemonDialog: false,
  }),
  computed: {
    ...mapState('pokemons', {
      pokemons: ({ pokemonsList: { data } }) => (data ? data.results : []),
      pokemonsCount: ({ pokemonsList: { data } }) => (data ? data.count : 0),
      loading: ({ pokemonsList: { loading } }) => loading,
      error: ({ pokemonsList: { error } }) => error,
    }),
  },
  mounted() {
    this.$store.dispatch('pokemons/getPokemonsList')
  },
}
</script>
